//
//  Accel1ViewController.m
//  Accel1
//
//  Created by Steven Luis on 10/28/11.
//  Copyright 2011 FIU. All rights reserved.
//

#import "Accel1ViewController.h"

#define INTERVAL  0.03 // 30 measurements per second
#define NORMALIZE(x) (x+1.0)/2.0  // normalize accelerometer readings for progress bar: (-1..1) to (0..1)
#define STRINGF(x) [NSString stringWithFormat:@"%f", x] // convert a float to a string

#define XTAG 0 // UI objects that refer to accellerometer x values
#define YTAG 1 // UI objects that refer to accellerometer y values
#define ZTAG 2 // UI objects that refer to accellerometer z values

@implementation Accel1ViewController
@synthesize progressBar;
@synthesize labelValues;
@synthesize movingButtonOutlet;

- (void)dealloc
{
    [movingButtonOutlet release];
    [progressBar release];
    [labelValues release];
    [super dealloc];
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

/*
// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad
{
    [super viewDidLoad];
}
*/

- (void)viewDidUnload
{
    [self setMovingButtonOutlet:nil];
    [self setProgressBar:nil];
    [self setLabelValues:nil];
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return YES;
}

#pragma mark - Overide ViewController Delegate Methods

-(void) viewWillAppear: (BOOL) animated {
    
    [super viewWillAppear: (BOOL) animated];
     
     NSLog (@"Monitoring accelerometer");
    UIAccelerometer *myAccel = [UIAccelerometer sharedAccelerometer ];
    
    [myAccel setUpdateInterval: INTERVAL];
    [myAccel setDelegate:self];
     
}

- (void) viewDidDisappear:(BOOL)animated {
    [super viewWillDisappear:animated];
    [[UIAccelerometer sharedAccelerometer] setDelegate:nil];
    
}

#pragma mark - Get Accelerometer data

- (void) accelerometer:(UIAccelerometer *)accelerometer didAccelerate:(UIAcceleration *)acceleration {
    
//    NSLog (@" %f %f %f", [acceleration x], [acceleration y], [acceleration z]);
    
    for (UIProgressView * thisBar in progressBar) {
        switch (thisBar.tag) {
            case XTAG : 
                thisBar.progress = NORMALIZE([acceleration x]);
                break;
            case YTAG:
                thisBar.progress = NORMALIZE([acceleration y]);
                break;
            case ZTAG:
                thisBar.progress = NORMALIZE([acceleration z]);
                break;
            default:
                break;
        }
    }
    
    for (UILabel *thisLabel in labelValues) {
        switch (thisLabel.tag) {
            case XTAG :
                thisLabel.text = STRINGF([acceleration x]);
                break;
            case YTAG :
                thisLabel.text = STRINGF([acceleration y]);
                break;
            case ZTAG:
                thisLabel.text = STRINGF([acceleration z]);
                break;
            
            default:
                break;
        }
    }
    
}

@end
